      subroutine lin_interp(x1,x2,x,f1,f2,f)
      implicit none
c
c     Purpose: linear interpolation of quantity "f" between f1 and f2
c
c     Inputs:
c       + x1: absicca where f1 is given
c       + x2: absicca where f2 is given
c       + x : absiccas where f is interpolated
c       + f1: quantity f defined at x1
c       + f2: quantity f defined at x2
c
c     Output: f is the quantity interpolated between f1 and f2
c
      double precision x1,x2,x,f1,f2,f

      f=f1+(f2-f1)/(x2-x1)*(x-x1)

      return
      end



      subroutine exp_interp(pres1,pres2,pres,alt1,alt2,alt)
      implicit none
c
c     Purpose: exponential interpolation of quantity "alt" between "alt1" and "alt2"
c     Quantity "pres" is supposed to evolve as an exponential between "pres1" and "pres2":
c
c     pres(alt)=a*exp(-b*(alt-alt1))
c     pres(alt1)=pres1 => a=pres(1)
c     pres(alt2)=pres2 => b=1/(alt2-alt1)*ln(pres1/pres2)
c
      double precision pres1,pres2,pres
      double precision alt1,alt2,alt
      double precision a,b

      a=pres1
      b=1.0D+0/(alt2-alt1)*dlog(pres1/pres2)
      alt=alt1+1.0D+0/b*dlog(a/pres)

      return
      end
