      subroutine longitude_grid(Ns_phi,Nphi,phi)
      implicit none
      include 'max.inc'
      include 'param.inc'
c
c     Purpose: to compute the longitudinal discretization
c
c     Inputs:
c       + Ns_phi: number of angular sectors over each [0;pi/2] longitudinal interval
c     
c     Outputs:
c       + Nphi: total number of angular sectors over the [0;2pi] longitudinal interval
c       + phi: limits of angular sectors in radians (Nphi+1 values, from 0 to 2pi)
c
      integer strlen
      integer Ns_phi,Nphi,i
      double precision phi(0:Nphi_mx)
      double precision dphi
      character*100 label
      label='longitude_grid'

      phi(0)=0.0D+0

      dphi=pi/2.0D+0/Ns_phi
      do i=1,Ns_phi-1
         phi(i)=phi(i-1)+dphi
      enddo
      phi(Ns_phi)=pi/2.0D+0
      do i=Ns_phi+1,2*Ns_phi-1
         phi(i)=phi(i-1)+dphi
      enddo
      phi(2*Ns_phi)=pi
      do i=2*Ns_phi+1,3*Ns_phi-1
         phi(i)=phi(i-1)+dphi
      enddo
      phi(3*Ns_phi)=3.0D+0*pi/2.0D+0
      do i=3*Ns_phi+1,4*Ns_phi-1
         phi(i)=phi(i-1)+dphi
      enddo
      phi(4*Ns_phi)=2.0D+0*pi
      Nphi=4*Ns_phi

c     Debug
c      do i=0,Nphi
c         write(*,*) 'phi(',i,')=',phi(i)
c      enddo
c     Debug

      return
      end
