c     Copyright (C) 2008-2009 Vincent Eymet
c
c     Planet_EMC is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 3, or (at your option)
c     any later version.

c     Planet_EMC is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with Planet_EMC; if not, see <http://www.gnu.org/licenses/>
c
      subroutine mc_solar(dim,ref,vri,toa_ad,pf,Nr,Ntheta,Nphi,
     &     Nb_gas,Nq,Nb_clouds,Na,
     &     r,theta,phi,rspace,T,r_mc,Nevent,Radius,Tsun,Rsun,dist,
     &     theta0,phi0,Nclouds,clouds_coord,
     &     lambda_gas_lo,lambda_gas_hi,w_quad,
     &     band_min,band_max,spectral_pdf,spectral_cumul,
     &     lambda_clouds_lo,lambda_clouds_hi,
     &     clouds_ka,clouds_ks,
     &     clouds_phase,clouds_g,
     &     Nzones,emissivity_zone,
     &     r_nodes,r_south_pole,r_north_pole,
     &     coeff_a,coeff_b,coeff_c,
     &     sum_flux_up,
     &     sum_flux_dn,
     &     sum_flux_net,
     &     sum_flux_toa,
     &     sum_budget,
     &     sum2_flux_up,
     &     sum2_flux_dn,
     &     sum2_flux_net,
     &     sum2_flux_toa,
     &     sum2_budget,
     &     ninvalid)
      implicit none
      include 'max.inc'
      include 'mpif.h'
c
c     Purpose: to run a simulation over 'Nevent' "solar photons"
c

c     Inputs
      integer dim,ref,vri,toa_ad,pf
      integer Nr(1:Ntheta_mx,1:Nphi_mx),Ntheta,Nphi,Nzones
      integer Nb_gas,Nq,Nb_clouds,Na
      integer Nevent,Nclouds
c      integer band,quad
      double precision r(0:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision theta(0:Ntheta_mx)
      double precision phi(0:Nphi_mx)
      double precision rspace
      double precision T(0:Nz_mx+1,1:Ntheta_mx,1:Nphi_mx)
      double precision r_mc(1:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision Radius,Tsun,Rsun,dist,theta0,phi0
      double precision clouds_coord(1:Nclouds_mx,1:6)
      double precision lambda_gas_lo(1:Nb_gas_mx)
      double precision lambda_gas_hi(1:Nb_gas_mx)
      double precision w_quad(1:Nq_mx)
      integer band_min,band_max
      double precision spectral_pdf(1:Nb_gas_mx,1:Nq_mx)
      double precision spectral_cumul(0:Ncumul_mx)
c      double precision gas_ka(1:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
c      double precision gas_ks(1:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision lambda_clouds_lo(1:Nb_clouds_mx)
      double precision lambda_clouds_hi(1:Nb_clouds_mx)
      double precision clouds_ka(1:Nclouds_mx,1:Nb_clouds_mx)
      double precision clouds_ks(1:Nclouds_mx,1:Nb_clouds_mx)
      double precision clouds_phase(1:Nclouds_mx,1:Nb_clouds_mx,
     &     1:Nangle_mx,1:2)
      double precision clouds_g(1:Nclouds_mx,1:Nb_clouds_mx)
c      double precision ground_emissivity(1:Ntheta_mx,1:Nphi_mx)
c      double precision space_emissivity(1:Ntheta_mx,1:Nphi_mx)
      double precision emissivity_zone(1:Nzones_mx,1:4)
c      double precision emissivity(1:Nzones_mx)
c      double precision n_ref(1:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
c      double precision spectral_weight
      double precision r_nodes(1:Ntheta_mx,1:Nphi_mx,1:4)
      double precision r_south_pole,r_north_pole
      double precision coeff_a(1:Ntheta_mx,1:Nphi_mx,1:4)
      double precision coeff_b(1:Ntheta_mx,1:Nphi_mx,1:4)
      double precision coeff_c(1:Ntheta_mx,1:Nphi_mx,1:4)

c     Outputs
      double precision sum_flux_up(0:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision sum_flux_dn(0:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision sum_flux_net(0:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision sum_flux_toa(1:Ntheta_mx,1:Nphi_mx,
     &     1:Ntheta_mx,1:Nphi_mx,1:Nb_gas_mx)
      double precision sum_budget(0:Nz_mx+1,1:Ntheta_mx,1:Nphi_mx)
      double precision sum2_flux_up(0:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision sum2_flux_dn(0:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision sum2_flux_net(0:Nz_mx,1:Ntheta_mx,1:Nphi_mx)
      double precision sum2_flux_toa(1:Ntheta_mx,1:Nphi_mx,
     &     1:Ntheta_mx,1:Nphi_mx,1:Nb_gas_mx)
      double precision sum2_budget(0:Nz_mx+1,1:Ntheta_mx,1:Nphi_mx)

c     MPICH
      integer ierr,errorcode,np,pindex
      integer stat(MPI_STATUS_SIZE)
c     MPICH
c     temp
      integer Ntest
      integer strlen,valid
      integer db,event,out
      double precision solar_power
      character*100 label
cc     temporary contributions
      integer Ncontrib_flux_up,Ncontrib_flux_dn
      integer Ncontrib_flux_net,Ncontrib_flux_toa
      integer Ncontrib_budget
      integer flux_idx_up(1:Ncontrib_mx,1:5)
      integer flux_idx_dn(1:Ncontrib_mx,1:5)
      integer flux_idx_net(1:Ncontrib_mx,1:5)
      integer flux_idx_toa(1:Ncontrib_mx,1:6)
      integer budget_idx(1:Ncontrib_mx,1:5)
      double precision flux_contrib_up(1:Ncontrib_mx)
      double precision flux_contrib_dn(1:Ncontrib_mx)
      double precision flux_contrib_net(1:Ncontrib_mx)
      double precision flux_contrib_toa(1:Ncontrib_mx)
      double precision budget_contrib(1:Ncontrib_mx)
      double precision flux_weight_up(1:Ncontrib_mx)
      double precision flux_weight_dn(1:Ncontrib_mx)
      double precision flux_weight_net(1:Ncontrib_mx)
      double precision flux_weight_toa(1:Ncontrib_mx)
      double precision budget_weight(1:Ncontrib_mx)
c     output
      integer ninvalid
      Ntest=1000000
      
c     MPICH
c     Get 'np', the number of processes
      call MPI_COMM_SIZE(MPI_COMM_WORLD,np,ierr)
c     Get 'pindex', the index of the current process
      call MPI_COMM_RANK(MPI_COMM_WORLD,pindex,ierr)
c     MPICH

      label='subroutine mc_solar'
c      call solar_emission(band,lambda_gas_lo,lambda_gas_hi,
c     &     Tsun,Rsun,dist,solar_power)

      call init_sums(Nr,Ntheta,Nphi,Nb_gas,toa_ad,
     &     sum_flux_up,sum_flux_dn,sum_flux_net,
     &     sum_flux_toa,sum_budget,
     &     sum2_flux_up,sum2_flux_dn,sum2_flux_net,
     &     sum2_flux_toa,sum2_budget)
      db=0
      ninvalid=0
      do event=1,Nevent
 111     continue
c     Debug
c         write(*,*) 'event in:',event,' process:',pindex
c         if ((pindex.eq.2).and.(event.eq.23170880)) then
c            db=1
c         else
c            db=0
c         endif
c     Debug
         call solar_photon(db,dim,event,toa_ad,
     &        Nr,Ntheta,Nphi,
     &        Nb_gas,Nq,Nb_clouds,
     &        r,theta,phi,rspace,theta0,phi0,Nclouds,Na,
     &        clouds_coord,
     &        lambda_gas_lo,lambda_gas_hi,w_quad,
     &        band_min,band_max,spectral_pdf,spectral_cumul,
     &        Tsun,Rsun,dist,
     &        lambda_clouds_lo,lambda_clouds_hi,
     &        clouds_ka,clouds_ks,
     &        clouds_phase,clouds_g,
     &        Nzones,emissivity_zone,
     &        T,r_mc,ref,vri,pf,
     &        r_nodes,r_south_pole,r_north_pole,
     &        coeff_a,coeff_b,coeff_c,
     &        Ncontrib_flux_up,
     &        Ncontrib_flux_dn,
     &        Ncontrib_flux_net,
     &        Ncontrib_flux_toa,
     &        Ncontrib_budget,
     &        flux_idx_up,
     &        flux_idx_dn,
     &        flux_idx_net,
     &        flux_idx_toa,
     &        budget_idx,
     &        flux_contrib_up,
     &        flux_contrib_dn,
     &        flux_contrib_net,
     &        flux_contrib_toa,
     &        budget_contrib,
     &        flux_weight_up,
     &        flux_weight_dn,
     &        flux_weight_net,
     &        flux_weight_toa,
     &        budget_weight,
     &        valid)
c     Debug
         if (Ncontrib_flux_toa.gt.1) then
            write(*,*) 'Error from ',label(1:strlen(label)),' :'
            write(*,*) 'Ncontrib_flux_toa=',Ncontrib_flux_toa
            stop
         endif
c     Debug

c     Debug
         if (db.eq.1) then
            write(*,*) 'valid=',valid
         endif
c     Debug
         if (valid.eq.0) then
c            write(*,*) 'aborting path for event:',event,
c     &           ' process index:',pindex
            ninvalid=ninvalid+1
            goto 111
         endif

         call update_solar_results(db,toa_ad,
     &        Ncontrib_flux_up,
     &        Ncontrib_flux_dn,
     &        Ncontrib_flux_net,
     &        Ncontrib_flux_toa,
     &        Ncontrib_budget,
     &        flux_idx_up,
     &        flux_idx_dn,
     &        flux_idx_net,
     &        flux_idx_toa,
     &        budget_idx,
     &        flux_contrib_up,
     &        flux_contrib_dn,
     &        flux_contrib_net,
     &        flux_contrib_toa,
     &        budget_contrib,
     &        flux_weight_up,
     &        flux_weight_dn,
     &        flux_weight_net,
     &        flux_weight_toa,
     &        budget_weight,
     &        lambda_gas_lo,
     &        lambda_gas_hi,
     &        w_quad,
     &        sum_flux_up,
     &        sum_flux_dn,
     &        sum_flux_net,
     &        sum_flux_toa,
     &        sum_budget,
     &        sum2_flux_up,
     &        sum2_flux_dn,
     &        sum2_flux_net,
     &        sum2_flux_toa,
     &        sum2_budget)
c     Debug
c         write(*,*) 
c         write(*,*) sum_flux_toa(flux_idx_toa(Ncontrib_flux_toa,1),
c     &        flux_idx_toa(Ncontrib_flux_toa,2),
c     &        flux_idx_toa(Ncontrib_flux_toa,3),
c     &        flux_idx_toa(Ncontrib_flux_toa,4))
c         write(*,*) sum2_flux_toa(flux_idx_toa(Ncontrib_flux_toa,1),
c     &        flux_idx_toa(Ncontrib_flux_toa,2),
c     &        flux_idx_toa(Ncontrib_flux_toa,3),
c     &        flux_idx_toa(Ncontrib_flux_toa,4))
c     Debug

c     Debug
         if (db.eq.1) then
            write(*,*) 'end of event=',event
         endif
c     Debug

c     Debug
         call is_integer(dble(event)/dble(Ntest),out)
         if ((pindex.eq.1).and.(out.eq.1)) then
            write(*,*) 'process:',pindex,' event=',event
         endif
c     Debug

      enddo ! event

c     Debug
      if (pindex.eq.1) then
         write(*,*) 'process:',pindex,' end of chunk'
      endif
c     Debug

      return
      end
