c     Copyright (C) 2008-2009 Vincent Eymet
c
c     Planet_EMC is free software; you can redistribute it and/or modify
c     it under the terms of the GNU General Public License as published by
c     the Free Software Foundation; either version 3, or (at your option)
c     any later version.

c     Planet_EMC is distributed in the hope that it will be useful,
c     but WITHOUT ANY WARRANTY; without even the implied warranty of
c     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
c     GNU General Public License for more details.

c     You should have received a copy of the GNU General Public License
c     along with Planet_EMC; if not, see <http://www.gnu.org/licenses/>
c
      subroutine read_planet(Radius,Tsun,Rsun,dist,theta0,phi0)
      implicit none
      include 'max.inc'
      include 'param.inc'
c
c     Purpose: to read information about the planet
c     requires: file "data/planet.in"
c
c     output:
c       + Radius: equatorial radius (m)
c       + Tsun: temperature of the star (K)
c       + Rsun: radius of the star (m)
c       + dist: distance from the planet to its star (m)
c       + theta0: latitude of the point where the star is at the zenith (rad)
c       + phi0: longitude of the point where the star is at the zenith (rad)
c

c     output
      double precision Radius
      double precision Tsun
      double precision Rsun
      double precision dist
      double precision theta0
      double precision phi0
c     temp
      integer ios,i,strlen
      character*100 label,datafile
      label='subroutine read_planet'

      datafile='./data/planet.in'
      open(10,file=datafile(1:strlen(datafile)),
     &     status='old',iostat=ios)
      if (ios.ne.0) then        ! file not found
         write(*,*) 'Error from ',label(1:strlen(label)),' :'
         write(*,*) 'File could not be found:'
         write(*,*) datafile(1:strlen(datafile))
         stop
      endif

      do i=1,5
         read(10,*)
      enddo
      read(10,*) Radius
      read(10,*)
      read(10,*) Tsun
      read(10,*)
      read(10,*) Rsun
      read(10,*)
      read(10,*) dist
      read(10,*)
      read(10,*) theta0
      read(10,*)
      read(10,*) phi0
      close(10)

c     conversions
      Radius=Radius*1.0D+3 ! km -> m
      Rsun=Rsun*1.0D+3 ! km -> m
      dist=dist*1.0D+3 ! km -> m
      theta0=theta0*pi/180.0D+0 !  -> rad
      phi0=phi0*pi/180.0D+0 !  -> rad

      return
      end
